<template>
    <AdminMenuBar>


        <el-tabs type="border-card" v-model="mainTabActive" @tab-change="handleTabClick" stretch>

            <el-tab-pane name="first">
                <template #label>
                    <div v-if="mainTabActive == 'first'" class="flex items-center gap-sm">
                        <el-icon>
                            <Loading />
                        </el-icon>
                        <h1>Ongoing Orders</h1>
                    </div>
                    <p v-else>Ongoing Orders</p>
                </template>
                <el-tooltip content="Refresh" placement="bottom" effect="dark">
                    <el-button class="margin-bottom-sm" @click="refreshOngoing">
                        <el-icon>
                            <RefreshRight />
                        </el-icon>
                    </el-button>
                </el-tooltip>
                <el-table :data="filteredTransactions" v-loading="transactionLoading"
                    :default-sort="{ prop: 'date', order: 'descending' }" style="width: 100%" size="large" fit
                    @row-click="handleRowClick">
                    <el-table-column prop="id" label="Order #" sortable />
                    <el-table-column label="User Name" prop="user_name" sortable></el-table-column>
                    <el-table-column label="Mode of Payment" sortable>
                        <template #default="{ row }">
                            {{ row.payment_method.toUpperCase() }}
                        </template>
                    </el-table-column>
                    <el-table-column prop="total_quantity" label="Quantity" sortable />

                    <el-table-column prop="created_at_formatted" label="Order Date" sortable />
                    <el-table-column label="Status">
                        <template #header>
                            <el-select v-model="ongoingSelectedStatus" size="large">
                                <el-option label="Statuses" value="" />
                                <el-option label="Pending" value="1" />
                                <el-option label="Processing" value="2" />
                                <el-option label="Delivering" value="3" />
                                <el-option label="Completed" value="4" />

                                <el-option label="To Return Requested" value="5" />
                                <el-option label="To Return Accepted" value="6" />
                                <el-option label="Return Processing" value="7" />
                                <el-option label="Return Completed" value="8" />
                            </el-select>
                        </template>
                        <template #default="{ row }">
                            <el-tag :class="row.transaction_status.title.toLowerCase().split(' ').join('-')" effect="dark"
                                round size="large">
                                {{ row.transaction_status.title }}
                            </el-tag>
                        </template>
                    </el-table-column>
                </el-table>

            </el-tab-pane>

            <el-tab-pane label="Finished Orders" name="second">
                <template #label>
                    <div v-if="mainTabActive == 'second'" class="flex items-center gap-sm">
                        <el-icon>
                            <SuccessFilled />
                        </el-icon>
                        <h1>Finished Orders</h1>
                    </div>
                    <p v-else>Finished Orders</p>
                </template>

                <el-tooltip content="Refresh" placement="bottom" effect="dark">
                    <el-button class="margin-bottom-sm" @click="refreshFinished">
                        <el-icon>
                            <RefreshRight />
                        </el-icon>
                    </el-button>
                </el-tooltip>

                <el-table :data="finishedFilteredTransactions" v-loading="transactionLoading"
                    :default-sort="{ prop: 'date', order: 'descending' }" style="width: 100%" size="large" fit
                    @row-click="handleRowClick">
                    <el-table-column prop="id" label="Order #" sortable />
                    <el-table-column label="User Name" prop="user_name" sortable></el-table-column>
                    <el-table-column label="Mode of Payment" sortable>
                        <template #default="{ row }">
                            {{ row.payment_method.toUpperCase() }}
                        </template>
                    </el-table-column>
                    <el-table-column prop="total_quantity" label="Quantity" sortable />

                    <el-table-column prop="created_at_formatted" label="Order Date" sortable />
                    <el-table-column label="Status">
                        <template #header>
                            <el-select v-model="finishedSelectedStatus" size="large">
                                <el-option label="Statuses" value="" />
                                <el-option label="Successful" value="4" />
                                <el-option label="Return Completed" value="8" />
                                <el-option label="To Return Rejected" value="9" />
                                <el-option label="Rejected" value="10" />
                            </el-select>
                        </template>
                        <template #default="{ row }">
                            <el-tag :class="row.transaction_status.title.toLowerCase().split(' ').join('-')" effect="dark"
                                round size="large">
                                {{ row.transaction_status.title }}
                            </el-tag>
                        </template>
                    </el-table-column>
                </el-table>
            </el-tab-pane>

            <el-tab-pane label="Monitor Sales" name="third">
                <template #label>
                    <div v-if="mainTabActive == 'third'" class="flex items-center gap-sm">
                        <el-icon>
                            <Money />
                        </el-icon>
                        <h1>Monitor Sales</h1>
                    </div>
                    <p v-else>Monitor Sales</p>
                </template>

                <div class="flex items-center margin-bottom-sm gap-md">
                    <el-tooltip content="Refresh" placement="bottom" effect="dark">
                        <el-button @click="fetchSales" size="large">
                            <el-icon>
                                <RefreshRight />
                            </el-icon>
                        </el-button>
                    </el-tooltip>




                    <el-date-picker v-model="startingDate" type="date" placeholder="Starting day" value-format="YYYY-MM-DD"
                        :shortcuts="shortcuts" size="large" @change="changeDate" />
                    <el-date-picker v-model="endingDate" type="date" placeholder="Ending day" value-format="YYYY-MM-DD"
                        :shortcuts="shortcuts" size="large" @change="changeDate" />

                    <el-tooltip content="Export to Excel" placement="bottom" effect="dark">
                        <el-button @click="exportToExcel" size="large">
                            <el-icon>
                                <Download />
                            </el-icon>
                        </el-button>
                    </el-tooltip>
                </div>
                <el-table :data="salesData" v-loading="salesLoading" height="650"
                    :default-sort="{ prop: 'date', order: 'descending' }" style="width: 100%" size="large" fit
                    @row-click="handleRowClick" show-summary>
                    <el-table-column prop="id" label="Order #" sortable />
                    <el-table-column label="User Name" prop="user_name" sortable></el-table-column>
                    <el-table-column label="Mode of Payment" sortable>
                        <template #default="{ row }">
                            {{ row.payment_method.toUpperCase() }}
                        </template>
                    </el-table-column>
                    <el-table-column prop="created_at_formatted" label="Order Date" sortable />

                    <el-table-column prop="total_quantity" label="Quantity" sortable />
                    <el-table-column prop="overall_total" label="Total" sortable />
                </el-table>

                <!-- <el-pagination v-model:current-page="salesCurrentPage" :page-size="10" layout="total, prev, pager, next"
                    :total="100" @size-change="handleSizeChange" @current-change="handleCurrentChange" small background /> -->
            </el-tab-pane>

        </el-tabs>



        <el-dialog v-model="dialogTableVisible" style="color: var(--el-color-black)">
            <template #title>
                <span class="flex">
                    <h1 class="no-margin">Order #{{ currentDataOpen.id }} Details</h1>

                    <el-tag class="margin-left-sm"
                        :class="currentDataOpen.transaction_status.title.toLowerCase().split(' ').join('-')" effect="dark"
                        round size="medium">
                        {{ currentDataOpen.transaction_status.title }}
                    </el-tag>
                </span>
            </template>

            <el-tabs class="no-margin margin-bottom-md" v-model="dialogActiveTab" style="height:100px;" stretch>
                <el-tab-pane name="first">
                    <template #label>
                        <h1 style="color:var( --el-text-color-regular);">User Information</h1>
                    </template>

                    <div class="flex flex-column " style="color:var(--el-text-color-secondary)">
                        <div class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Name</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.user_name }}
                            </p>
                        </div>
                        <div class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Email</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.user.email }}
                            </p>
                        </div>

                        <div class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Phone</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.user_phone_number }}
                            </p>
                        </div>

                        <div class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Address</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.user.address }}
                            </p>
                        </div>
                    </div>

                </el-tab-pane>
                <el-tab-pane name="second">
                    <template #label>
                        <h1 style="color:var(--el-text-color-regular)">Order Information</h1>
                    </template>
                    <div class="flex flex-column " style="color:var(--el-text-color-secondary)">
                        <div v-if="currentDataOpen.comment" class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Payment method</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.payment_method == 'cod' ? 'Paid by Cash on Delivery' : 'Paid by GCash' }}
                            </p>
                        </div>

                        <div v-if="currentDataOpen.comment" class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Order note</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.comment }}
                            </p>
                        </div>

                        <div v-if="currentDataOpen.to_return_comment" class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm">Return Note</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.to_return_comment }}
                            </p>
                        </div>

                        <div v-if="currentDataOpen.canceled_comment" class="flex flex-row items-space-between">
                            <h1 class="no-margin font-size-sm"> {{ currentDataOpen.to_return_comment ? "Return rejected note" : " Cancel note" }}</h1>
                            <p class="no-margin font-size-sm">
                                {{ currentDataOpen.canceled_comment }}
                            </p>
                        </div>
                    </div>
                </el-tab-pane>
            </el-tabs>

            <el-collapse accordion v-if="currentDataOpen.payment_method == 'gcash'">
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">View Transaction Proof</h1>
                        </div>
                      </template>
                      <el-image
                        style="width: 500px; height: 500px"
                        :src="'/online_transactions/' + currentDataOpen.proof_of_payment"
                        fit="cover"
                      />
                    </el-collapse-item>
                  </el-collapse>

            <hr class=" margin-bottom-sm" />
            <h1 class="margin-top-sm no-margin">Orders</h1>
            <el-table :data="currentDataOpen.orders" height="250" show-summary size="small">
                <el-table-column property="item.name" label="Product" />
                <el-table-column property="quantity" label="Quantity" />
                <el-table-column property="item.price" label="Price" />
                <el-table-column property="item_sub_total" label="Sub Total" />
            </el-table>
            <hr />
            <h1 class="margin-top-sm no-margin">Transaction Process</h1>
            <el-steps class="margin-bottom-md padding-sm" :active="active"
                :direction="!transactionCondition(currentDataOpen.transaction_status.id, [4, 10, 11]) ? 'vertical' : 'horizontal'"
                finish-status="success"
                :style="!transactionCondition(currentDataOpen.transaction_status.id, [4, 10, 11]) ? 'height: 190px; overflow-y:auto' : null">
                <el-step title="Pending" :icon="Stopwatch" :description="currentDataOpen.pending_at" />

                <template v-if="!transactionCondition(currentDataOpen.transaction_status.id, [10, 11])">
                    <el-step title="Processing" :icon="Loading" :description="currentDataOpen.processing_at" />
                    <el-step title="Delivering" :icon="Van" :description="currentDataOpen.delivering_at" />
                    <el-step title="Orders Received" :icon="Check" :description="currentDataOpen.completed_at" />

                    <template v-if="currentDataOpen.transaction_status.id >= 5">
                        <el-step title="Return Request" :icon="Memo"
                            :description="currentDataOpen.to_return_requested_at" />
                        <template v-if="!transactionCondition(currentDataOpen.transaction_status.id, [9])">
                            <el-step title="Request Accepted" :icon="DocumentChecked"
                                :description="currentDataOpen.to_return_accepted_at" />
                            <el-step title="Return Processing" :icon="Loading"
                                :description="currentDataOpen.to_return_process_at" />

                            <el-step title="Return Completed" :icon="Check"
                                :description="currentDataOpen.return_completed_at" />
                        </template>
                        <el-step v-else title="To Return Rejected" :icon="CircleCloseFilled"
                            :description="currentDataOpen.to_return_rejected_at" />
                    </template>
                </template>
                <template v-else>

                    <el-step v-if="transactionCondition(currentDataOpen.transaction_status.id, [10])" title="Rejected"
                        :icon="CircleCloseFilled" :description="currentDataOpen.rejected_at" />
                    <el-step v-if="transactionCondition(currentDataOpen.transaction_status.id, [11])" title="Canceled"
                        :icon="CircleCloseFilled" :description="currentDataOpen.canceled_at" />
                </template>

            </el-steps>

            <template v-if="!currentDataOpen.orders.some(order => order.hasOwnProperty('finished_transaction_id'))">

                <el-button @click="rejectRequest(currentDataOpen.id, 10)" type="danger"
                    v-if="transactionCondition(currentDataOpen.transaction_status.id, [1])">Reject Order</el-button>


                <el-button @click="endTransaction(currentDataOpen.id)" type="success"
                    v-if="(!currentDataOpen.orders.some(order => order.hasOwnProperty('finished_transaction_id')) && transactionCondition(currentDataOpen.transaction_status.id, [4, 8]))">
                    End transaction
                </el-button>

                <template v-if="transactionCondition(currentDataOpen.transaction_status.id, [5])">
                    <el-button @click="rejectRequest(currentDataOpen.id, 9)" type="danger">
                        Reject Request
                    </el-button>

                    <el-button @click="next" type="success">
                        Accept Request
                    </el-button>
                </template>
                <el-button type="success" @click="next"
                    v-if="!transactionCondition(currentDataOpen.transaction_status.id, [4, 5, 8])">Next
                    step</el-button>
            </template>


        </el-dialog>
    </AdminMenuBar>
</template>

<style scoped>
.el-table:hover {
    cursor: pointer;
}

/* Pending */
</style>
<script setup>
import axios from "axios";
import { ref, computed, onMounted, onBeforeUnmount } from "vue";
import { Stopwatch, Loading, Van, Check, Memo, RefreshRight, DocumentChecked, CircleCloseFilled, Download, SuccessFilled, Money } from "@element-plus/icons-vue";
import { ElMessageBox } from "element-plus";
import transactionHandler from "../../helpers/transactionHandler";
import FileSaver from 'file-saver';

const { transactionLoading, fetchOrders, finishOrder } = transactionHandler;

const loading = ref(false);

const salesLoading = ref(false);
const ongoingData = ref([]);
const finishedData = ref([]);
const salesData = ref([]);

const mainTabActive = ref('first');
const dialogActiveTab = ref('first');

const startingDate = ref();
const endingDate = ref();

const handleTabClick = async () => {
    if (mainTabActive.value == 'first') {
        await fetchOrders(ongoingData, "admin", "ongoing");
    } else if (mainTabActive.value == 'second') {
        await fetchOrders(finishedData, "admin", "finished");
    } else {
        await fetchSales();
    }
}

const changeDate = async () => {
    const fetchData = {
        "starting_date": startingDate.value,
        "ending_date": endingDate.value
    };

    await fetchSales(fetchData);
}

const exportToExcel = () => {
    salesLoading.value = true;
    const fetchData = {
        "starting_date": startingDate.value,
        "ending_date": endingDate.value
    };
    let token = localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token");
    const headers = {
        Authorization: `Bearer ${token}`,
    };
    let fileName = "sales_report";

    if (fetchData.starting_date && fetchData.ending_date) {
        fileName = `${fetchData.starting_date}_${fetchData.ending_date}`;
    } else if (fetchData.starting_date) {
        fileName = `from_${fetchData.starting_date}`;
    } else if (fetchData.ending_date) {
        fileName = `to_${fetchData.ending_date}`;
    }
    axios.post('/api/admin/excelExport', fetchData, { headers: headers, responseType: 'blob' })
        .then(response => {
            const blob = new Blob([response.data]);
            FileSaver.saveAs(blob, `${fileName}.xlsx`);
            salesLoading.value = false;
        })
        .catch(error => {
            console.log(error);
        });
}

const transactionCondition = (id, valuesToCheck) => {
    return (valuesToCheck.includes(id));
}

const refreshOngoing = async () => {
    await fetchOrders(ongoingData, "admin", "ongoing");
}

const refreshFinished = async () => {
    await fetchOrders(finishedData, "admin", "finished");
}

const ongoingSelectedStatus = ref("");
const filteredTransactions = computed(() => {
    if (ongoingSelectedStatus.value === "") {
        return ongoingData.value.transactions;
    } else {
        return ongoingData.value.transactions.filter((transaction) => {
            return transaction.transaction_status.id == ongoingSelectedStatus.value;
        });
    }
});

const finishedSelectedStatus = ref("");
const finishedFilteredTransactions = computed(() => {
    if (finishedSelectedStatus.value === "") {
        return finishedData.value.transactions;
    } else {
        return finishedData.value.transactions.filter((transaction) => {
            return transaction.transaction_status.id == finishedSelectedStatus.value;
        });
    }
});

const endTransaction = (id) => {
    ElMessageBox.confirm(
        "Are you sure you want to end this transaction?",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        const endTransactData = {
            id: id,
        }
        dialogTableVisible.value = false;
        await finishOrder(endTransactData)
        await fetchOrders(ongoingData, "admin", "ongoing");

    });
}

const rejectRequest = (id, newTransactId) => {
    ElMessageBox.prompt("Are you sure you want to reject this order request #" + id + "? If so please provide a valid reason before we proceed.",
        "Warning", {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
    }).then(async ({ value }) => {
        const cancelData = {
            id: id,
            new_transaction_id: newTransactId,
            reject_comment: value
        }
        dialogTableVisible.value = false;
        await finishOrder(cancelData)
        await fetchOrders(ongoingData, "admin", "ongoing");
    });
}

const fetchSales = async (fetchData) => {
    try {
        salesLoading.value = true;

        let token = localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token");
        const headers = {
            Authorization: `Bearer ${token}`,
        };


        let res = await axios({
            method: "POST",
            url: "/api/admin/fetchSales",
            data: fetchData,
            headers: headers,
        });
        salesData.value = res.data;
    } catch (error) {
        salesData.value = [];
        console.log(error);
    } finally {
        salesLoading.value = false;
    }
};

const active = ref(0);
const dialogTableVisible = ref(false);
const currentDataOpen = ref([]);
const handleRowClick = (row) => {
    dialogTableVisible.value = true;
    currentDataOpen.value = row;
    active.value = row.transaction_status.id;
};
const next = () => {
    ElMessageBox.confirm(
        "Are you sure the transaction is going to proceed into the next step?",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        active.value++;
        dialogTableVisible.value = false;

        await updateTransactionStatus();
    });
};

const updateTransactionStatus = async () => {
    try {
        const apiUrl = `/api/updateTransactStatus`;
        const headers = {
            Authorization: `Bearer ${localStorage.getItem("admin_token") ??
                sessionStorage.getItem("admin_token")
                }`,
        };
        const requestData = {
            id: currentDataOpen.value.id,
            transaction_status: active.value,
        };

        await axios.post(apiUrl, requestData, {
            headers: headers,
        });
        await fetchOrders(ongoingData, "admin", "ongoing");
    } catch (error) {
        console.error("Error updating transaction status:", error);
    }
};

const shortcuts = [
    {
        text: 'Today',
        value: new Date(),
    },
    {
        text: 'Yesterday',
        value: () => {
            const date = new Date()
            date.setTime(date.getTime() - 3600 * 1000 * 24)
            return date
        },
    },
    {
        text: 'A week ago',
        value: () => {
            const date = new Date()
            date.setTime(date.getTime() - 3600 * 1000 * 24 * 7)
            return date
        },
    },
]

onMounted(async () => {
    Echo.channel('notification')
    .listen('MessageNotification', async (data) => {
        dialogTableVisible.value = false;
        if(data.message == "Update admin"){
            await fetchOrders(ongoingData, "admin", "ongoing");
        }
    });
    await fetchOrders(ongoingData, "admin", "ongoing");
});
 
onBeforeUnmount(async () => {
  Echo.leave('notification');
});

</script>
